function [cell1,cell2]=basic_model()

close all
%-------------------------------------------------------------------
%Inicialization
[name,data]=textread('parameters.txt','%s%f','commentstyle','matlab');
[x,y]=textread('fixed_positions.txt','%f%f','commentstyle','matlab');

global numTxPU numTxSU numSensors N0 Xmin Xmin0 XminNC0 Xav XavNC XminNC Ptx hb hm sigmaS cont

numTxPU=data(1);
numTxSU=data(2);
numSensors=data(3);
sigmaS=data(4);
hb=data(5);
hm=data(6);
prob=data(7);
bits=data(8);
controlqueue=data(9);
Ptx=data(10); 
cont=data(11);
Xav=data(12);
XavNC=data(13);
work=data(14);
keep_param=data(15);

P=[x,y]';

Xmin0=Xav/10;
XminNC0=XavNC./10;

Xav=linspace(Xav,Xav/1000,work);
Xmin=Xav./10;

XavNC=linspace(XavNC,XavNC/1000,work);
XminNC=XavNC./10;

kb=1.3806e-23;   %Boltzmann constant
T=300;           %Room tempeture

%--------------------------------------------

%----------------MAIN PROGRAM----------------
%------------ Basic Inicialization ------------- 
D=CalculateDistance(P,P); %Distance between cells
r=D(1,2)/2; %R is the radio cell
close all
plottools('on')
hold on

% Calculating Dnc, loss and shadowing among cells.
if keep_param==0
    Dnc=10.^(CalculateFixedLosses(D(1,2),hb,hm,sigmaS)/10);
    f=Dnc;
end

%Calculating Noise Power constant   
    
N0=kb*T;   %equivalent to -120dBm over 200 kHz 

    for i=1:2
        eval(['S' int2str(i) '=sensor_structure([P(:,' int2str(i) ') P(:,' int2str(i+2) ')],r);']); % Create the sensor structure around the cell
        eval(['cell' int2str(i) '=create_cell([P(:,' int2str(i) ') P(:,' int2str(i+2)...
            ')],r,S' int2str(i) ',work);']); % Creating cells
       if keep_param
            load fixed_parameters
            eval(['cell' int2str(i) '.TxSU=pos' int2str(i) '.TxSU;']);
            eval(['cell' int2str(i) '.c0=pos' int2str(i) '.c0;']);
            eval(['cell' int2str(i) '.d0=pos' int2str(i) '.d0;']);
            eval(['cell' int2str(i) '.e0=pos' int2str(i) '.e0;']);
            eval(['cell' int2str(i) '.int0=pos' int2str(i) '.int0;']);
            eval(['cell' int2str(i) '.e0cross=pos' int2str(i) '.e0cross;']);
            eval(['cell' int2str(i) '.int0cross=pos' int2str(i) '.int0cross;']); 
        else
            eval(['cell' int2str(i) '.d0=[cell' int2str(i) '.d0 Dnc*ones(numTxSU,1)];']);
        end
        eval(['representation(cell' int2str(i) ');']); % Plotting Cells
    end

hold off
%grid

if keep_param==0
    [cell1,cell2]=cross_interference(cell1,cell2); 
else
    f=pos1.d0(1,end);
end

for i=1:2
    eval(['cell' int2str(i) '=CalculateFastFading(cell' int2str(i) ');']); % Adding fast fading
end

%-------Output Inicialization----------------             
    
    Ropt1=zeros(1,1);
    Ropt2=zeros(1,1);
    SINR1out=zeros(1,1);
    SINRth1out=zeros(1,1);
    SINR2out=zeros(1,1);
    SINRth2out=zeros(1,1);
    Qout1=zeros(work,numTxSU);
    Qout2=zeros(work,numTxSU);
    Xout1=zeros(work,2);
    Xout2=zeros(work,2);
    rxpacks1=zeros(work,numTxSU);
    droppacks1=zeros(work,numTxSU);
    rxpacks2=zeros(work,numTxSU);
    droppacks2=zeros(work,numTxSU); 
        
%---------Main looping-----------------------        

while cont<work
       
%--Arrival proccess and Choosing the most suitable secondary transmitter
   
    for i=1:2
        eval(['[Aq,cell' int2str(i) ']=ArrivalProcess(cell' int2str(i)...
            ',prob,bits,controlqueue);']); % Adding fast fading
        eval(['cell' int2str(i) '=first_transmitter(cell' int2str(i) ');']);
    end

    cell1.whoTxOtherCell=cell2.whoTx;
    cell2.whoTxOtherCell=cell1.whoTx;
    
    %--------- RxSU tests if the estimated datarate can be supported
    
    for i=1:2
        if eval(['cell' int2str(i) '.whoTx~=0']);
            eval(['cell' int2str(i) '=DataRateOptimization(f,cell' int2str(i) ');']); % Here, datarate is obtained from a probabilistic distribution
            eval(['Ropt' int2str(i) '=[Ropt' int2str(i) ',cell' int2str(i) '.ropt];']);
            eval(['[cell' int2str(i) ',SINR' int2str(i) ',SINRth' int2str(i) ']=test_datarate(cell' int2str(i) ');']);
            eval(['SINR' int2str(i) 'out=[SINR' int2str(i) 'out,SINR' int2str(i) '];']);
            eval(['SINRth' int2str(i) 'out=[SINRth' int2str(i) 'out,SINRth' int2str(i) '];']);
        end
    end        

    %-------Updating parameters------------------

        for i=1:2 
            eval(['cell' int2str(i) '=interferqueue(cell' int2str(i) ');']); %Interference queue
            if eval(['cell' int2str(i) '.ack==1']);
                eval(['cell' int2str(i) '.Q=dataqueue(cell' int2str(i) '.Q,cell'...
                    int2str(i) '.ropt,0,cell' int2str(i) '.whoTx);']); %Data queue
                eval(['cell' int2str(i) '.ack=0;']);
                eval(['cell' int2str(i) '.ropt=0;']);
                eval(['cell' int2str(i) '.whoTx=0;']);
                eval(['cell' int2str(i) '.whoTxOtherCell=0;']);
            end
        end
        eval(['cell' int2str(i) '=CalculateFastFading(cell' int2str(i) ');']); %Fast fading
    
    
%---------- Output ---------------------------
        
    Qout1(cont,:)=cell1.Q;
    Qout2(cont,:)=cell2.Q;
    Xout1(cont,:)=[sum(cell1.X(1:numSensors)),cell1.X(numSensors+1)];
    Xout2(cont,:)=[sum(cell2.X(1:numSensors)),cell2.X(numSensors+1)];
    rxpacks1(cont,:)=cell1.rxpacks;
    droppacks1(cont,:)=cell1.droppacks;
    rxpacks2(cont,:)=cell2.rxpacks;
    droppacks2(cont,:)=cell2.droppacks;
        
%---------------------------------------------    
    cont=cont+1;
end 

pos1=cell1;
pos2=cell2;
if keep_param==0
    save('fixed_parameters','pos1','pos2');
end
SINR1av=mean(SINR1out(2:end));
SINRth1av=mean(SINRth1out(2:end));
SINR2av=mean(SINR2out(2:end));
SINRth2av=mean(SINRth2out(2:end));

Ropt1avg=mean(Ropt1(2:end));
Ropt2avg=mean(Ropt2(2:end));
for i=1:numTxSU
    eval(['Qout1' int2str(i) 'avg=mean(Qout1(:,' int2str(i) '));']);
    eval(['Qout2' int2str(i) 'avg=mean(Qout2(:,' int2str(i) '));']);
    eval(['percentage_rxpacks1' int2str(i) '=rxpacks1(end-1,' int2str(i)...
        ')/(rxpacks1(end-1,' int2str(i) ')+droppacks1(end-1,' int2str(i) '))*100;']);
    eval(['percentage_droppacks1' int2str(i) '=droppacks1(end-1,' int2str(i)...
        ')/(rxpacks1(end-1,' int2str(i) ')+droppacks1(end-1,' int2str(i) '))*100;']);
    eval(['percentage_rxpacks2' int2str(i) '=rxpacks2(end-1,' int2str(i)...
        ')/(rxpacks2(end-1,' int2str(i) ')+droppacks2(end-1,' int2str(i) '))*100;']);
    eval(['percentage_droppacks2' int2str(i) '=droppacks2(end-1,' int2str(i)...
        ')/(rxpacks2(end-1,' int2str(i) ')+droppacks2(end-1,' int2str(i) '))*100;']);
end

figure
subplot(2,1,1)
plot(SINR1out,'b');
hold on
plot(SINRth1out,'g');
legend(['SINR. SINRavg=' num2str(SINR1av)],['SINRth. SINRthavg=' num2str(SINRth1av)])
hold off
title('Relation SINR/SINRth from cell 1')
ylabel('dBs')
xlabel('Iterations')
subplot(2,1,2)
plot(SINR2out,'b');
hold on
plot(SINRth2out,'g');
legend(['SINR. SINRavg=' num2str(SINR2av)],['SINRth. SINRthavg=' num2str(SINRth2av)])
hold off
title('Relation SINR/SINRth from cell 2')
ylabel('dBs')
xlabel('Iterations')
hold off

figure
plot(Ropt1,'mo-');
hold on
plot(Ropt2,'cx-');
legend(['Data rate cell 1. Average rate=' num2str(Ropt1avg)],['Data rate cell 2. Average rate=' num2str(Ropt2avg)])
hold off
title('Optimal data rate from cell1 and cell2')
ylabel('Bits/Iteration/Hz')
xlabel('Iterations')

figure
subplot(2,1,1)
plot(Qout1(:,1),'m');
hold on
plot(Qout1(:,2),'c');
plot(Qout1(:,3),'y')
legend(['Data queue 1. Q1avg=' num2str(Qout11avg)],['Data queue 2. Q2avg=' num2str(Qout12avg)],...
    ['Data queue 3. Q3avg=' num2str(Qout13avg)]);
hold off
title('Data queues of different secondary transmitter from cell 1')
ylabel('Bits')
xlabel('Iterations')
subplot(2,1,2)
plot(Qout2(:,1),'m');
hold on
plot(Qout2(:,2),'c');
plot(Qout2(:,3),'y')
legend(['Data queue 1. Q1avg=' num2str(Qout21avg)],['Data queue 2. Q2avg=' num2str(Qout22avg)],...
    ['Data queue 3. Q3avg=' num2str(Qout23avg)]);
hold off
title('Data queues of different secondary transmitter from cell 2')
ylabel('Bits')
xlabel('Iterations')

figure
subplot(2,1,1)
plot(Xout1(:,1),'b+-');
hold on
plot(Xout2(:,1),'bs-');
plot(Xav,'r');
legend('X1','X2','Xavmin');
hold off
title('Interference queue from cell 1 and cell 2')
ylabel('dBm')
xlabel('Iterations')
subplot(2,1,2)
plot(Xout1(:,2),'b+-');
hold on
plot(Xout1(:,2),'bs-');
plot(XavNC,'r');
legend('Xnc1','Xnc2','Xncav');
hold off
title('Neighbour interference queue from both cells')
ylabel('dBm')
xlabel('Iterations')

figure
subplot(3,1,1)
plot(rxpacks1(:,1),'ms');
hold on
plot(droppacks1(:,1),'mo');
plot(droppacks1(:,1)+rxpacks1(:,1),'m+');
legend(['Rx packets. %Rxpckt=' num2str(percentage_rxpacks11)],['Dropped packets. %Drpckt=' num2str(percentage_droppacks11)],'Total packets');
hold off
title('Total packets, received packets and dropped packets from first Tx, in secondary system cell 1')
ylabel('Packets')
xlabel('Iterations')

subplot(3,1,2)
plot(rxpacks1(:,2),'cs');
hold on
plot(droppacks1(:,2),'co');
plot(droppacks1(:,2)+rxpacks1(:,2),'c+');
legend(['Rx packets. %Rxpckt=' num2str(percentage_rxpacks12)],...
    ['Dropped packets. %Drpckt=' num2str(percentage_droppacks12)],'Total packets');
hold off
title('Total packets, received packets and dropped packets from second Tx, in secondary system cell 1')
ylabel('Packets')
xlabel('Iterations')

subplot(3,1,3)
plot(rxpacks1(:,3),'ys');
hold on
plot(droppacks1(:,3),'yo');
plot(droppacks1(:,3)+rxpacks1(:,3),'y+');
legend(['Rx packets. %Rxpckt=' num2str(percentage_rxpacks13)],...
    ['Dropped packets. %Drpckt=' num2str(percentage_droppacks13)],'Total packets');
hold off
title('Total packets, received packets and dropped packets from third Tx, in secondary system cell 1')
ylabel('Packets')
xlabel('Iterations')

figure
subplot(3,1,1)
plot(rxpacks2(:,1),'ms');
hold on
plot(droppacks2(:,1),'mo');
plot(droppacks2(:,1)+rxpacks2(:,1),'m+');
legend(['Rx packets. %Rxpckt=' num2str(percentage_rxpacks21)],...
    ['Dropped packets. %Drpckt=' num2str(percentage_droppacks21)],'Total packets');
hold off
title('Total packets, received packets and dropped packets from first Tx, in secondary system cell 2')
ylabel('Packets')
xlabel('Iterations')

subplot(3,1,2)
plot(rxpacks2(:,2),'cs');
hold on
plot(droppacks2(:,2),'co');
plot(droppacks2(:,2)+rxpacks2(:,2),'c+');
legend(['Rx packets. %Rxpckt=' num2str(percentage_rxpacks22)],...
    ['Dropped packets. %Drpckt=' num2str(percentage_droppacks22)],'Total packets');
hold off
title('Total packets, received packets and dropped packets from second Tx, in secondary system cell 2')
ylabel('Packets')
xlabel('Iterations')

subplot(3,1,3)
plot(rxpacks2(:,3),'ys');
hold on
plot(droppacks2(:,3),'yo');
plot(droppacks2(:,3)+rxpacks2(:,3),'y+');
legend(['Rx packets. %Rxpckt=' num2str(percentage_rxpacks23)],...
    ['Dropped packets. %Drpckt=' num2str(percentage_droppacks23)],'Total packets');
hold off
title('Total packets, received packets and dropped packets from third Tx, in secondary system cell 2')
ylabel('Packets')
xlabel('Iterations')
