function cell=interferqueue(cell)
%Inputs: Xav average interference, Xmin control max power allocated, z sensor measure 
%X0 is the previos interference queue value
%Outputs: X is the new interference queue value

global numTxPU numSensors Xav Xmin XavNC XminNC Ptx cont

X0=cell.X;

for i=1:numSensors
    SP=sum(Ptx.*cell.e(1:numTxPU))+sum(Ptx.*cell.ecross(1:numTxPU));
    if (cell.whoTx~=0)&&(cell.whoTxOtherCell~=0)
        BP=Ptx*cell.d(cell.whoTx,i)+Ptx*cell.ecross(numTxPU+cell.whoTxOtherCell)...
            +sum(Ptx.*cell.e(1:numTxPU))+sum(Ptx.*cell.ecross(1:numTxPU));
    elseif cell.whoTx~=0 
        BP=Ptx*cell.d(cell.whoTx,i)+sum(Ptx.*cell.e(1:numTxPU))+...
            sum(Ptx.*cell.ecross(1:numTxPU));
    elseif cell.whoTxOtherCell~=0 
        BP=Ptx*cell.ecross(numTxPU+cell.whoTxOtherCell)...
            +sum(Ptx.*cell.e(1:numTxPU))+sum(Ptx.*cell.ecross(1:numTxPU));
    else
        BP=sum(Ptx.*cell.e(1:numTxPU))+sum(Ptx.*cell.ecross(1:numTxPU));
    end

    cell.X(i)=max(0,X0(i)-Xav(cont)-SP)+BP;

    if cell.X(i)<Xmin(cont)
        cell.X(i)=Xmin(cont);
    end
end

%Xnc falta compararlo con Xavnc y saber si hay que hacer SP y BP

SPnc=sum(Ptx.*cell.int(1:numTxPU))+sum(Ptx.*cell.intcross(1:numTxPU));

if cell.whoTx~=0
    BPnc=Ptx*cell.intcross(cell.whoTx+numTxPU)+sum(Ptx.*cell.int(1:numTxPU))...
        +sum(Ptx.*cell.intcross(1:numTxPU));
else
    BPnc=0;
end

cell.X(numSensors+1)=max(0,X0(numSensors+1)-XavNC(cont)-SP)+BPnc;

if cell.X(numSensors+1)<XminNC(cont)
        cell.X(numSensors+1)=XminNC(cont);
end